
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef rflex_TCLSERV_CLIENT_ERROR_H
#define rflex_TCLSERV_CLIENT_ERROR_H

#include <server/rflexError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum rflex_error {
	E_rflex_OK					  			= 0,

	/* module errors */
	E_rflex_BRAKES_ON                      = S_rflex_BRAKES_ON,
	E_rflex_BAD_REF_DATA                   = S_rflex_BAD_REF_DATA,
	E_rflex_BAD_CMD_DATA                   = S_rflex_BAD_CMD_DATA,
	E_rflex_TRACKING_ON                    = S_rflex_TRACKING_ON,
	E_rflex_BAD_WDOGREF                    = S_rflex_BAD_WDOGREF,
	E_rflex_CANNOT_WRITE_FILE              = S_rflex_CANNOT_WRITE_FILE,
	E_rflex_CANNOT_OPEN_FILE               = S_rflex_CANNOT_OPEN_FILE,
	E_rflex_GYRO_ERROR                     = S_rflex_GYRO_ERROR,
	E_rflex_SHOCK                          = S_rflex_SHOCK,
	E_rflex_POSTER_NOT_UPDATED             = S_rflex_POSTER_NOT_UPDATED,
	E_rflex_CMD_STOP_TRACK                 = S_rflex_CMD_STOP_TRACK,
	E_rflex_BAD_REF                        = S_rflex_BAD_REF,
	E_rflex_POSTER_NOT_FOUND               = S_rflex_POSTER_NOT_FOUND,
	E_rflex_CANNOT_READ_POSTER             = S_rflex_CANNOT_READ_POSTER,
	E_rflex_NOT_CONNECTED                  = S_rflex_NOT_CONNECTED,
	E_rflex_CONNECTION_FAILED              = S_rflex_CONNECTION_FAILED,
	E_rflex_REF_NOT_UPDATED                = S_rflex_REF_NOT_UPDATED,
	E_rflex_LOW_LEVEL_BATTERY              = S_rflex_LOW_LEVEL_BATTERY,
	E_rflex_MANUAL                         = S_rflex_MANUAL,
	E_rflex_EMERGENCY_STOP                 = S_rflex_EMERGENCY_STOP,
	E_rflex_NO_MOTION                      = S_rflex_NO_MOTION,


	/* std errors */
	E_rflex_ACTIVITY_INTERRUPTED           = S_rflex_stdGenoM_ACTIVITY_INTERRUPTED,
	E_rflex_TOO_MANY_ACTIVITIES            = S_rflex_stdGenoM_TOO_MANY_ACTIVITIES,
	E_rflex_ACTIVITY_FAILED                = S_rflex_stdGenoM_ACTIVITY_FAILED,
	E_rflex_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_rflex_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_rflex_UNKNOWN_ACTIVITY               = S_rflex_stdGenoM_UNKNOWN_ACTIVITY,
	E_rflex_FORBIDDEN_ACTIVITY_TRANSITION  = S_rflex_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_rflex_SYSTEM_ERROR                   = S_rflex_stdGenoM_SYSTEM_ERROR,
	E_rflex_ACTIVITY_ALREADY_ENDED         = S_rflex_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_rflex_WAIT_INIT_RQST                 = S_rflex_stdGenoM_WAIT_INIT_RQST,
	E_rflex_CONTROL_CODEL_ERROR            = S_rflex_stdGenoM_CONTROL_CODEL_ERROR,
	E_rflex_EXEC_TASK_SUSPENDED            = S_rflex_stdGenoM_EXEC_TASK_SUSPENDED,
	E_rflex_BAD_BLOCK_TYPE                 = S_rflex_stdGenoM_BAD_BLOCK_TYPE,
	E_rflex_BAD_POSTER_TYPE                = S_rflex_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum rflex_error rflex_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int rflex_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the rflex context.
 *
 * Returns NULL in case of failure
 */
const char* rflex_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
